function x = cantor(n, plotflag)

% x = cantor(n, plotflag) calculates and returns the edge points
% of the n-th iteration of the Cantor set.

if nargin < 1
    error(['At least one input arguments are required. Please type ' ...
        '''help cantor'' for usage information.']);
end

if nargin < 2
    plotflag = 0;
end

if n <= 0   % end of recursion
    x = [0; 1];
else        % recursive method call
    x0 = cantor(n-1);

    % calculate new coordinates
    x = (1/3)*[x0; x0+2];
end

if plotflag == 1
    y = zeros(size(x));
    plot(x', y', '.');
    title('The Cantor set');
end